@use '../../../global/styles/utilities' as *;
@use '../../../global/styles/styles-variables' as *;
@use './styles/progress-indicator.variables' as *;

:host {
  @include digi-progress-indicator--variables;
  $base: '.digi-progress-indicator';

  #{$base} {
    font-size: var(--digi--progress-indicator--label--font-size);
    margin: var(--digi--progress-indicator--margin);
    box-sizing: border-box;

    &:not(.digi-progress-indicator--linear) {
      --digi--progress-indicator--step--line--color--active: var(--digi--progress-indicator--step--line--color);
    }


    &__content {
      font-family: var(--digi--global--typography--font-family--default);
    }

    &__heading {
      font-size: var(--digi--typography--heading-2--font-size--desktop);
      font-weight: var(--digi--progress-indicator--heading--font-weight);
      margin: 0;
      margin-bottom: 0.5rem;

      &--mobile {
        font-size: var(--digi--progress-indicator--heading--mobile--font-size);
        margin-bottom: 0.35rem;
      }
    }

    &__next {
      font-size: var(--digi--typography--body--font-size--desktop);
      font-style: italic;
      color: var(--digi--color--text--neutral);
      margin: 0;
      &--mobile {
        font-size: var(--digi--typography--tag--font-size--desktop);
      }
    }

    &__icon {
      --digi--icon--height: var(--digi--progress-indicator--icon--width);
      --digi--icon--width: var(--digi--progress-indicator--icon--height);
      --digi--icon--color: var(--digi--progress-indicator--icon--color);

      &--warning {
        --digi--icon--height: var(--digi--progress-indicator--icon-status--height);
        --digi--icon--width: var(--digi--progress-indicator--icon-status--width);
      }

      &--error {
        margin-top: 4px;
        --digi--icon--height: var(--digi--progress-indicator--icon-status--height);
        --digi--icon--width: var(--digi--progress-indicator--icon-status--width);
        --digi--icon--color: var(--digi--progress-indicator--icon--error--color);
      }
    }



    &__label {
      font-family: var(--digi--global--typography--font-family--default);
      font-size: var(--digi--progress-indicator--label--font-size);
      line-height: var(--digi--typography--body--line-height--desktop);
      color: var(--digi--color--text--primary);
      margin: var(--digi--progress-indicator--label--margin);

      &--steps {
        font-weight: 600;
      }
    }

    &__validation-label {
      font-family: var(--digi--global--typography--font-family--default);
      font-size: var(--digi--progress-indicator--label--font-size);
      line-height: var(--digi--typography--body--line-height--desktop);
      color: var(--digi--color--text--primary);
      padding: var(--digi--gutter--medium) var(--digi--gutter--medium);
      
      display: flex;
      align-items: center;
      span{
        display: inline-block;
        margin-left: 8px;
      }
      &--warning{
        background-color: var(--digi--color--background--warning-2);
      }
      &--error{
        background-color: var(--digi--color--background--danger-2);
      }
    }

    &__list {
      position: relative;
      list-style: none;
      padding: 0;
      margin: 0;
      margin-top: 24px;
      margin-bottom: 16px;
      display: grid;
      grid-template-columns: repeat(auto-fit, minmax(calc(var(--digi--progress-indicator--step--size) + var(--digi--progress-indicator--gap)), 1fr));
      //grid-template-columns: repeat(auto-fit, calc(var(--digi--progress-indicator--step--size) + var(--digi--progress-indicator--gap)));
      --digi--progress-indicator--step--size: var(--digi--progress-indicator--step--size--large);
      --digi--progress-indicator--step--size--active: var(--digi--progress-indicator--step--size--active--large);
      --digi--progress-indicator--gap: var(--digi--progress-indicator--gap--x-large);
    }

    &__step {
      position: relative;
      height: var(--digi--progress-indicator--step--size--active);
      z-index: 2;
      &:last-child {
        width: var(--digi--progress-indicator--step--size--active);

        &::before {
          display: none;
        }
      }

      &::before {
        content: "";
        position: absolute;
        top: 50%;
        transform: translateY(-50%);
        display: inline-block;
        width: calc(100% - 34px);
        left: 30px;
        border-top: var(--digi--progress-indicator--step--line--style) var(--digi--progress-indicator--step--line--width) var(--digi--progress-indicator--step--line--color);
      }

      &--active {
        --digi--progress-indicator--border-color: var(--digi--progress-indicator--border-color--active);
        --digi--progress-indicator--step--background: var(--digi--progress-indicator--step--background--active);
        --digi--progress-indicator--step--size: var(--digi--progress-indicator--step--size--active);
        --digi--progress-indicator--step--line--color: var(--digi--progress-indicator--step--line--color--active);
        --digi--progress-indicator--step--line--style: solid;

        .digi-progress-indicator__step-indicator {
          margin-left: calc((var(--digi--progress-indicator--step--size--large) - var(--digi--progress-indicator--step--size--active--large))/2);
        }
      }

      &--current {
        --digi--progress-indicator--step--line--color: var(--digi--progress-indicator--step--line--color--current);
        --digi--progress-indicator--step--line--style: dashed;

        span {
          box-shadow: inset 0px 0px 0px 2px var(--digi--color--background--primary);
        }
      }

      &--warning,
      &--error {
        --digi--progress-indicator--step--background: transparent;

        .digi-progress-indicator__step-indicator {
          border: 0;
        }
      }
    }

    &__step-indicator {
      width: var(--digi--progress-indicator--step--size);
      height: var(--digi--progress-indicator--step--size);
      border: var(--digi--progress-indicator--step--line--style) var(--digi--progress-indicator--step--line--width) var(--digi--progress-indicator--border-color);
      background: var(--digi--progress-indicator--step--background);
      box-sizing: border-box;
      position: absolute;
      display: inline-flex;
      align-items: center;
      justify-content: center;
      top: 50%;
      transform: translateY(-50%);
      border-radius: 50%;
    }

    &__step-number {
      @include digi--a11y--sr-only;
    }

    &__circle-wrapper {
      display: flex;
      align-items: center;
    }

    &__circle {
      position: relative;
      display: inline-block;

      svg {
        transform: rotate(-90deg)
      }
    }

    &__circle-label {
      position: absolute;
      top: 50%;
      left: 50%;
      transform: translate(-50%, -50%);
      font-family: var(--digi--global--typography--font-family--default);
      font-size: var(--digi--typography--tag--font-size--desktop);
      line-height: var(--digi--typography--body--line-height--desktop);
      color: var(--digi--color--text--primary);
      font-weight: 600;
      margin: 0;
    }

    &__circle-step-unfinished {
      stroke: var(--digi--progress-indicator--border-color);
    }

    &__circle-step-completed {
      stroke: var(--digi--progress-indicator--step--background--active);
    }
    &__circle-step-warning {
      stroke: var(--digi--progress-indicator--icon--warning--color);
    }
    &__circle-step-error {
      stroke: var(--digi--progress-indicator--icon--error--color);
      
    }
  }
}



